﻿
using FFmpeg.AutoGen;
using System.Text.Json.Serialization;

namespace FNZCM2.Abstractions.Models.Metadata;

public class AudioInfo
{
    [JsonPropertyName("f")] public required AVSampleFormat SampleFormat { get; init; }
    [JsonPropertyName("r")] public required int? SampleRate { get; init; }
    [JsonPropertyName("d")] public required int? BitPerSample { get; init; }

    public override string ToString()
    {
        return $"{BitPerSample}/{SampleRate} {SampleFormat.ToString().Substring("AV_SAMPLE_FMT_".Length)}";
    }
}